{% extends "plantilla.html"%}


{% block contenido%}
{% load static %}

<div class="main-container">
  <div class="pd-ltr-20">
    <div class="card-box pd-20 height-100-p mb-30">
      <div class="row align-items-center">
        <div class="col-md-4">
          <h4 class="font-20 weight-500 mb-10 text-capitalize">
            LISTADO CLIENTES <div class="weight-600 font-30 text-blue">

              <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal">
                NUEVO CLIENTE
              </button></div>
          </h4>
        </div>
        <div class="col-md-8">

        </div>
      </div>
    </div>
    <table class="table " cellspacing="0" width="100%" id="tbl">

    </table>
    <table id="miTabla" class="display">
      <thead>
        <tr>
          <td>ID</td>
          <td>CEDULA </td>
          <td>NOMBRE </td>
          <td>DIRECCION </td>
          <td>TELEFONO </td>
          <td>CORREO </td>
          <td>FOTO </td>
          <td>ACCIONES</td>
        </tr>
      </thead>
      <tbody>
        {% for cliente in clientes %}
        <tr>
          <td>{{cliente.id}}</td>
          <td>{{cliente.cedula}}</td>
          <td>{{cliente.nombre}}</td>
          <td>{{cliente.direccion}}</td>
          <td>{{cliente.telefono}}</td>
          <td>{{cliente.correo}}</td>
          <td>
              {% if cliente.foto %}
                  <a href="{{ cliente.foto.url }}" target="_blank">

                      <img src="{{ cliente.foto.url }}" style="max-width: 100px; max-height: 100px;">
                  </a>
              {% else %}
                  <b>N/A</b>
              {% endif %}
          </td>

          <td>
            <a href="/editarCliente/{{cliente.id}}" class="btn btn-warning">EDITAR</a>
            <a href="javascript:void(0)"
                onclick=
                "eliminar('/eliminarCliente/{{cliente.id}}');"
                class="btn btn-danger">
                  Eliminar
                </a>

          </td>
        </tr>
        {% endfor%}
      </tbody>
    </table>

    <!-- En tu script -->
    <script type="text/javascript">
    $(document).ready(function() {
        $('#miTabla').DataTable({
            dom: 'Bfrtip',
            buttons: [
                {
                    extend: 'pdfHtml5',
                    messageTop: 'PDF created by PDFMake with Buttons for DataTables.'
                },
                'print',
                'csv'
            ],
            "language": {
                "url": "https://cdn.datatables.net/plug-ins/1.11.5/i18n/Spanish.json" // Cambia a la URL correcta del archivo de idioma español
            }
            // Puedes agregar más opciones según tus requisitos
        });
    });
</script>
    </div>

  </div>



  <!-- Modal -->
  <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <form action="/guardarCliente/" method="post" enctype="multipart/form-data" id="frm_cliente">
            {% csrf_token %}

            <div class="row">
              <div class="col-md-6">
                <label for="nombre" class="form-label">Nombre</label>
                <input type="text" class="form-control" name="nombre" id="nombre" placeholder="Nombre" required>
              </div>
              <div class="col-md-6">
                <label for="cedula" class="form-label">Cédula</label>
                <input type="text" class="form-control" name="cedula" id="cedula" placeholder="Cédula" required>
              </div>
            </div>

            <div class="row">
              <div class="col-md-6">
                <label for="telefono" class="form-label">Teléfono</label>
                <input type="text" class="form-control" name="telefono" id="telefono" placeholder="Teléfono" required>
              </div>
              <div class="col-md-6">
                <label for="correo" class="form-label">Correo Electrónico</label>
                <input type="email" class="form-control" name="correo" id="correo" placeholder="Correo Electrónico" required>
              </div>
            </div>

            <div class="row">
              <div class="col-md-12">
                <label for="direccion" class="form-label">Dirección</label>
                <textarea class="form-control" name="direccion" id="direccion" placeholder="Dirección" required></textarea>
              </div>
              <div class="col-md-12">
                <label for="foto" class="form-label">Foto</label>
                <br>
                <input type="file" name="foto" id="foto" class="dropzone" accept="image/*">
              </div>
              <script>
                // Javascript para actualizar la imagen al cargar la página
                document.addEventListener('DOMContentLoaded', function () {
                    var imgSrc = "{{ cliente.foto.url }}";
                    var imagenPreview = document.getElementById('imagen-preview');

                    // Verificar si la imagen existe y es válida
                    if (imgSrc) {
                        imagenPreview.src = imgSrc;
                    }
                });
            </script>

            </div>

            <div class="col-md-12 mt-3">
              <center>
                <button type="submit" class="btn btn-primary"><i class="bi bi-floppy"></i>&nbsp; Guardar Cliente</button>
                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
              </center>
            </div>
          </form>
          <script>
            // Configuración de validación del formulario
            $("#frm_cliente").validate({
              rules: {
                'nombre': {
                  required: true,
                  lettersonly: true,
                  nombreApellido:true
                },
                'cedula': {
                  required: true,
                  number: true,
                  minlength: 10,
                  maxlength: 10
                },
                'telefono': {
                  required: true,
                  number: true,
                  minlength: 10,
                  maxlength: 10
                },
                'correo': {
                  required: true,
                  email: true
                },
                'direccion': {
                  required: true
                },
                'foto': {
                  required: true,
                  accept: "image/*"
                }
              },
              messages: {
                'nombre': {
                  required: "Por favor, ingresa el nombre",
                  lettersonly: "Solo se permiten letras"
                },
                'cedula': {
                  required: "Por favor, ingresa la cédula",
                  number: "Solo se permiten números",
                  minlength: "La cédula debe tener al menos 10 dígitos",
                  maxlength: "La cédula no debe tener más de 10 dígitos"
                },
                'telefono': {
                  required: "Por favor, ingresa el teléfono",
                  number: "Solo se permiten números",
                  minlength: "El telefono debe tener al menos 10 dígitos",
                  maxlength: "El telefono no debe tener más de 10 dígitos"
                },
                'correo': {
                  required: "Por favor, ingresa el correo",
                  email: "Ingresa un correo electrónico válido"
                },
                'direccion': {
                  required: "La dirección es obligatoria"
                },
                'foto': {
                  required: "Por favor, selecciona una foto",
                  accept: "Solo se permiten archivos de imagen"
                },

              },
              submitHandler: function(form) {
                form.submit();
              },
              highlight: function (element, errorClass, validClass) {
                // Añade clases de Bootstrap para resaltar errores
                $(element).addClass("is-invalid").removeClass("is-valid");
              },
              unhighlight: function (element, errorClass, validClass) {
                // Añade clases de Bootstrap cuando no hay errores
                $(element).removeClass("is-invalid").addClass("is-valid");
              },

            });

            // Agrega un método personalizado para validar solo letras
            $.validator.addMethod("lettersonly", function(value, element) {
              return /^[a-zA-Z\s]+$/.test(value);
            }, "Solo se permiten letras");
            $.validator.addMethod("nombreApellido", function(value, element) {
            return this.optional(element) || /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+\s[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+$/.test(value);
            }, "Por favor, introduce un nombre y un apellido con un espacio en el medio.");
        </script>



        </div>
        <div class="modal-footer">

        </div>
      </div>
    </div>
  </div>



{% endblock %}
